SystemOrganization addCategory: #Daliot!

Trait named: #HashProofTrait
	uses: {}
	category: 'Daliot'!

!HashProofTrait methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 17:50'!
= anObject

	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

!HashProofTrait methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 17:50'!
hash

	^(self gettersForEquality inject: 0 into: [:hash :symbol| hash bitXor: (self perform: symbol) hash]) hash! !

!PasteUpMorph methodsFor: '*Daliot' stamp: 'hjo 3/25/2008 18:05'!
collapseAllSystemWindows

	(self submorphs select: [:so| so class = SystemWindow ]) do: [: ow | ow collapse ]! !

!ByteString methodsFor: '*Daliot' stamp: 'hjo 4/5/2009 19:57'!
bigCamelCased

	^(self subStrings collect: [:x| x capitalized ]) concatenateAll! !

!ByteString methodsFor: '*Daliot' stamp: 'hjo 11/22/2008 12:43'!
caseReversed

	^self collect: [:each| each caseReversed]! !

!ByteString methodsFor: '*Daliot' stamp: 'hjo 4/5/2009 19:58'!
littleCamelCased

	^self bigCamelCased at: 1 modify: [:char| char asLowercase ]; yourself! !

!ByteString methodsFor: '*Daliot' stamp: 'hjo 5/14/2008 17:55'!
wordHighlightedStrings

	| index rangeStart rangeStop |
	index := 0.
	^self subStrings collect: [:subs|
		rangeStart := self indexOfSubCollection: subs startingAt: index.
		rangeStop := rangeStart + subs size - 1.
		index := rangeStop + 1.
		HighlightedString string: self rangeLeft: rangeStart rangeRight: rangeStop
		 ]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:35'!
canAccessAtRow: integer1 atColumn: integer2

	^(integer1 between: 1 and: self rowCount) and: [
		(integer2 between: 1 and: self columnCount)
		]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 22:01'!
columns

	^(1 to: self columnCount)
		collect: [:columnIndex| self atColumn: columnIndex ]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 11/12/2008 10:51'!
detectIndex: aBlockContext 

	^self indexOf: (self detect: aBlockContext)! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:34'!
insertDiagonal: anArray 

	| diagonalStream nondiagonalStream matrix |
	diagonalStream := anArray readStream.
	nondiagonalStream := contents readStream.
	matrix := self species rows: nrows columns: ncols+1.
	
	matrix indicesDo: [:ri :ci | matrix at: ri at: ci put: (ri=ci ifTrue:[diagonalStream next] ifFalse:[nondiagonalStream next]) ].
	^matrix! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 11/12/2008 11:18'!
isValidIndex: aPoint 

	^(aPoint x between: 1 and: self rowCount) and: [ aPoint y between: 1 and: self columnCount ]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 11/12/2008 10:44'!
multilineString

	^String fromLines:
		((1 to: self rowCount) collect: 
			[:rowIndex | String withAll: (self atRow: rowIndex) ])
	! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:15'!
readFromTextStream: aReadStream 

	self indicesDo: [ :ri :ci | self at: ri at: ci put: aReadStream nextNumberFromText ]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 22:01'!
rows

	^(1 to: self rowCount)
		collect: [:rowIndex| self atRow: rowIndex ]! !

!ByteSymbol methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:14'!
accessingBlock

	^[:each| each perform: self ]! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:40'!
asArrayedCollection

	^self asArray! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 6/12/2008 13:21'!
modify: aBlockContext 

	1 to: self size do: [:index| self at: index modify: aBlockContext ]! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 9/21/2008 18:21'!
modify: aBlockContext those: filteringBlock

	1 to: self size do: [ :index | 
		(filteringBlock value: (self at: index))
			ifTrue: [ self at: index modify: aBlockContext ] ]! !

!OrderedCollection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:31'!
removeAtIndex: anInteger 

	^self remove: (self at: anInteger)! !

!String class methodsFor: '*Daliot' stamp: 'hjo 6/16/2008 11:32'!
createPasswordForHost: aByteString id: aByteString2 

	| h i l o |
	h := aByteString asArray.
	i := aByteString2 asArray.
	l := ($0 to: $z) select: [:each| each isAlphaNumeric ].
	o := String new writeStream.

	1 to: (h size max: i size) do: [ : x | 
		o nextPut: 
			( l atWrap: 
				(l indexOf: (h atWrap: x)) * (l indexOf: (i atWrap: x) ) 
			)  ].
	^o contents! !

!String class methodsFor: '*Daliot' stamp: 'hjo 9/19/2009 15:49'!
empty

	^self new! !

!String class methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:58'!
fromLines: anArray

	^self streamContents: [:stream |

		anArray 
			do: [:each| stream nextPutAll: each ]
			separatedBy: [ "Dolphin 4: stream nextPutAll: self lineDelimiter" stream cr ].

	]! !

!String methodsFor: '*Daliot-display' stamp: 'hjo 3/27/2009 12:28'!
displayProgressAt: aPoint for: aCollection do: aBlock 

	"A shortcut version of #displayProgressAt:from:to:during: for a collectoin."
	| index |
	index := 0.
	^self displayProgressAt: aPoint from: 1 to: aCollection size during: 
		[:bar| aCollection do: [:each| index := index + 1. bar value: index. aBlock value: each ]].! !

!String methodsFor: '*Daliot-user intervention' stamp: 'hjo 8/25/2009 11:57'!
ifUserAnswersYes: yesBlock ifUserAnswersNo: noBlock

	^(self confirm: self)
		ifTrue: yesBlock
		ifFalse: noBlock! !

!String methodsFor: '*Daliot' stamp: 'hjo 5/15/2008 09:43'!
lazyInitializationCode

	^String streamContents: [:stream|
		stream nextPutAll: self.
		stream nextPutAll: ' isNil ifTrue: [
		self '.
		stream nextPutAll: self.
		stream nextPutAll: ': <Initialization object here>
	].
	^'.
		stream nextPutAll: self
		]! !

!String methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 10:30'!
lineFeedFiltered

	^self reject: [:character| character = Character lf ]! !

!String methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:57'!
lines

	^self subStrings: '
'! !

!SystemNavigation methodsFor: '*Daliot' stamp: 'hjo 7/8/2009 16:30'!
allCallsOn: aByteSymbol inPackagesNamed: anArray 
	|  filteringPackageInfos |
	filteringPackageInfos := anArray
				collect: [:each | PackageInfo named: each].
	^ (self systemNavigation allCallsOn: aByteSymbol)
		select: [:each | filteringPackageInfos
				anySatisfy: [:pi | pi includesMethodReference: each]]! !

!SystemNavigation methodsFor: '*Daliot' stamp: 'hjo 7/8/2009 16:35'!
browseAllCallsOn: aByteSymbol inPackagesNamed: anArray 
	"aByteSymbol: #clear
	anArray: #('Swazzo' 'Aida' 'Seaside')"
	self 
		browseMessageList: (self allCallsOn: aByteSymbol inPackagesNamed: anArray
) asSortedCollection
		name: 'Senders of ' , aByteSymbol , ' within packages'
		autoSelect: aByteSymbol keywords first
! !

!SystemNavigation methodsFor: '*Daliot' stamp: 'hjo 9/5/2009 20:24'!
browseBigMessage

	| tooLongMethods |
	tooLongMethods := ((CompiledMethod allInstances select: [:each| (#(DoIt DoIt:) includes: each selector) not ]) select:  [:each|  
		(each methodClass sourceCodeAt: each selector) asString size > 2000])
			collect: [:each| each methodReference]. 
	self browseMessageList: tooLongMethods name: 'Big methods' autoSelect: nil! !

!SystemNavigation methodsFor: '*Daliot' stamp: 'hjo 8/17/2009 20:11'!
browseMessage: aCompiledMethod

	| methodReference |
	methodReference := aCompiledMethod methodReference.
	self 
		browseMessageList: (Array with: methodReference)
		name: methodReference asStringOrText
		autoSelect: nil.! !

!SystemNavigation methodsFor: '*Daliot' stamp: 'hjo 8/17/2009 20:13'!
browseRandomMessage
	
	self systemNavigation browseMessage: CompiledMethod allInstances atRandom! !

!Morph methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 22:08'!
addDaliotsButtonMenuTo: aMenuMorph 

	aMenuMorph add: 'daliots button' translated target: self action: #openDaliotsButtonInHand! !

!Morph methodsFor: '*Daliot' stamp: 'hjo 10/25/2008 17:58'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu addLine].

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	self addHaloActionsTo: aMenu.
	self addDaliotsButtonMenuTo: aMenu.
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	self addCopyItemsTo: aMenu.
	self addPlayerItemsTo: aMenu.
	self addExportMenuItems: aMenu hand: aHandMorph.
	self addStackItemsTo: aMenu.
	self addMiscExtrasTo: aMenu.
	Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: unlockables first externalName)
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!Morph methodsFor: '*Daliot-Morphic' stamp: 'hjo 11/5/2008 10:04'!
captureImageInHand

	^((Display copy: self bounds) asMorph borderWidth:1; borderColor: Color black) openInHand! !

!Morph methodsFor: '*Daliot' stamp: 'hjo 10/25/2008 17:35'!
daliotsButton

	^DaliotsButtonMorph new
		target: self! !

!Morph methodsFor: '*Daliot-Morphic' stamp: 'hjo 11/1/2008 18:20'!
joystickUsed: aPoint

	self position: self position + aPoint! !

!Morph methodsFor: '*Daliot-Morphic' stamp: 'hjo 11/10/2009 12:27'!
moveSubmorphsIntoBounds

	self submorphs do: [:each| 
		each top < self top ifTrue: [ each top: self top ].
		each left < self left ifTrue: [ each left: self left ].
		each bottom > self bottom ifTrue: [ each bottom: self bottom ].
		each right > self right ifTrue: [ each right: self right ]
	].! !

!Morph methodsFor: '*Daliot' stamp: 'hjo 10/25/2008 17:43'!
openDaliotsButtonInHand

	^self daliotsButton openInHand! !

!Morph methodsFor: '*Daliot' stamp: 'hjo 10/25/2008 18:54'!
publishedActions

	^Array with: #flash with: #delete! !

!Morph methodsFor: '*Daliot-Morphic' stamp: 'hjo 3/31/2009 22:41'!
sameExtentButTransparentMorph

	"A space holder as big as I am."
	self fullBounds.
	^Morph new color: Color transparent; extent: self extent.! !

!Morph methodsFor: '*Daliot' stamp: 'hjo 10/18/2008 15:44'!
stopSteppingDeeply

	self stopStepping.
	self submorphs do: [:each| each stopSteppingDeeply]! !

!WriteStream methodsFor: '*Daliot' stamp: 'hjo 6/24/2008 17:50'!
nextPutParenthesisAround: aBlockContext 

	self nextPutAll: '( '.
	aBlockContext value.
	self nextPutAll: ' )'! !

!MenuItemMorph methodsFor: '*Daliot-Morphic' stamp: 'hjo 12/3/2008 17:16'!
buttonExpression
	self shouldBeImplemented! !

!CompiledMethod class methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 21:41'!
categoriesUsedFor: aByteSymbol 

	"Collects all the categories that shares same selector with me."
	^((self allInstances select: [:each| each selector = aByteSymbol ])
		collect: [:each | each methodCategory ]) asBag
	
	! !

!CompiledMethod methodsFor: '*Daliot' stamp: 'hjo 12/6/2008 21:22'!
author

	| preambleString |
	preambleString := self preamble subStrings: ''''.
	^preambleString isEmpty
		ifTrue: [ String new ]
		ifFalse: [ preambleString last subStrings first ]
	 ! !

!CompiledMethod methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 10:08'!
methodCategory

	^self methodClass organization categoryOfElement: self selector! !

!CompiledMethod methodsFor: '*Daliot' stamp: 'hjo 1/30/2011 14:25'!
preamble

	| file |
	self fileIndex == 0 ifTrue: [^ String new].  "no source pointer for this method"
	file := SourceFiles at: self fileIndex.
	file ifNil: [^ String new].  "sources file not available"
	"file does not exist happens in secure mode"
	file := [file readOnlyCopy] on: FileDoesNotExistException do:[:ex| nil].
	file ifNil: [^ String new].
	[^self getPreambleFrom: file at: (0 max: self filePosition - 3)] ensure: [file close].! !

!CompiledMethod methodsFor: '*Daliot' stamp: 'hjo 7/7/2009 13:43'!
referencingClasses

	^( (self literals collect: [:each| each value  ] ) select: [:each| each isKindOf: Class] ) reject: [:each| each == self methodClass]! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:17'!
ascendingSortBlock

	^[:objectA :objectB | (objectA perform: self) < (objectB perform: self) ]! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:22'!
descendingSortBlock

	^[:objectA :objectB | (objectA perform: self) > (objectB perform: self) ]! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:58'!
browseImplementorsOf: aByteSymbol 

	^ToolSet browseMessageSet: (self methodSetOfSelector: aByteSymbol)
 name: aByteSymbol , ' in ' , label autoSelect: nil! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 22:03'!
browseTestsAndImplementions

	self implementationSelectors do: [:sel| self browseTestsAndImplementionsOf: sel]! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 22:02'!
browseTestsAndImplementionsOf: aByteSymbol 

	self browseImplementorsOf: aByteSymbol.
	self browseTestsOn: aByteSymbol! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:58'!
browseTestsOn: aByteSymbol 

	^ToolSet browseMessageSet: (self testsMethodSetOn: aByteSymbol)
 name: 'tests on ' , aByteSymbol , ' in ' , label autoSelect: nil
	! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 20:59'!
implementationSelectors
	
	^((self methodItems
		reject: [:each| each actualClass allSuperclasses includes: TestCase])
			collect: [:each| each selector]) asSet! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 20:58'!
methodItems

	^items select: [:each| each isKindOf: MCMethodDefinition]! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:48'!
methodSetOfSelector: aByteSymbol 

	^(self methodItems select: [:i| i selector = aByteSymbol ])
		collect: [:i| i methodReference ]! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:46'!
testMethodItems

	^(self methodItems select: [:each| each actualClass allSuperclasses includes: TestCase ])
		select: [:each| each selector beginsWith: 'test']! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:53'!
testsMethodItemsOn: aByteSymbol 

	^self testMethodItems select: [:each| each compiledMethod messages includes: aByteSymbol ]! !

!MCSnapshotBrowser methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:54'!
testsMethodSetOn: aByteSymbol 

	^(self testsMethodItemsOn: aByteSymbol) collect: [:each| each methodReference ]! !

!MCMethodDefinition methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:47'!
compiledMethod

	^self actualClass compiledMethodAt: self selector! !

!MCMethodDefinition methodsFor: '*Daliot' stamp: 'hjo 12/30/2008 21:49'!
methodReference
	
	^MethodReference class: self actualClass selector: self selector! !

!Random class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 12:44'!
globalRandom

	^Smalltalk at: 'GlobalRandom' ifAbsentPut: [ Random new ]! !

!MethodContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:22'!
senderChainIncludesSelector: aByteSymbol 

	^sender selector = aByteSymbol or: [ sender senderChainIncludesSelector: aByteSymbol ]! !

!Behavior methodsFor: '*Daliot' stamp: 'hjo 2/20/2011 15:04'!
siblingclass: aByteSymbol instanceVariableNames: aByteString classVariableNames: aByteString3 poolDictionaries: aByteString4 category: aByteString5 

	^self superclass subclass: aByteSymbol instanceVariableNames: aByteString classVariableNames: aByteString3 poolDictionaries: aByteString4 category: aByteString5! !

!MethodReference methodsFor: '*Daliot' stamp: 'hjo 7/8/2009 16:23'!
belongsToPackageNamed: aByteString 
	
	^(PackageInfo named: aByteString) includesMethodReference: self! !

!SystemDictionary methodsFor: '*Daliot' stamp: 'hjo 12/24/2008 14:14'!
allClassesAndMetaclasses

	^self allClasses , self allMetaclasses
! !

!SystemDictionary methodsFor: '*Daliot' stamp: 'hjo 12/24/2008 14:15'!
allClassesThatCanUnderstandAllOf: arrayOfSelectors

	^(self allClassesAndMetaclasses
		select: [:e| arrayOfSelectors allSatisfy: [:s| e canUnderstand:s]]) asArray! !

!SystemDictionary methodsFor: '*Daliot' stamp: 'hjo 12/24/2008 14:13'!
allMetaclasses

	^self allClasses collect: [:c| c class ]
! !

!SystemDictionary methodsFor: '*Daliot' stamp: 'hjo 4/5/2009 15:40'!
reductionOfAllClassesThatCanUnderstandAllOf: arrayOfSelectors

	| classes classCount canBeRemoved |
	classes := self allClassesThatCanUnderstandAllOf: arrayOfSelectors.
	classCount := classes size.
	
	[canBeRemoved := OrderedCollection new. classes do: [:each| | s | s := each subclasses. (classes includesAllOf: s) ifTrue: [canBeRemoved addAll: s] ]. classes := classes copyWithoutAll: canBeRemoved. classes size < classCount ] whileTrue: [ classCount := classes size ].
	^classes
! !

!Dictionary methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 20:18'!
at: key add: element

	(self at: key ifAbsentPut: [OrderedCollection new]) add: element
	! !

!Dictionary methodsFor: '*Daliot' stamp: 'hjo 4/7/2009 18:58'!
keysAndValuesSelect: aBlockContext 

	| selected |
	selected := self species new.
	self keysAndValuesDo: [:key :value| (aBlockContext value: key value: value) ifTrue: [selected at: key put: value] ].
	^selected! !

!Preferences class methodsFor: '*Daliot' stamp: 'hjo 10/14/2008 09:20'!
setDefaultFontsForDaliot

	self setCodeFontTo: ((TextStyle named: #Accujen) fontOfSize: 17).
	self setSystemFontTo: ((TextStyle named: #Accuny) fontOfSize: 17).
	self setListFontTo: ((TextStyle named: #Accumon) fontOfSize: 15).
	self setMenuFontTo: ((TextStyle named: #Accujen) fontOfSize: 17).! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:14'!
ascendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) < (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:21'!
descendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) > (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 6/12/2008 12:55'!
ignoreError: aClass 
	
	^self on: aClass do: [:exception|  "do nothing" exception ]! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^ sender senderChainIncludesSelector: aByteSymbol ! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 3/29/2008 21:39'!
valueAllWithArguments: anArray 

	^anArray collect: [:parameterArray|   self valueWithArguments: parameterArray ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/18/2008 21:21'!
whileFalse: aBlockContext loopLimit: anInteger 

	|loopCount|
	loopCount := 0.
	self whileFalse: [aBlockContext value. loopCount := loopCount + 1. loopCount > anInteger ifTrue: [self error: 'Infinite loop suspected.' ] ]! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 6/29/2009 16:49'!
allMultiplied

	"WARNING implementation is same with #product"
	^self inject: 1 into: [:product :each| product * each ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 12/1/2009 22:44'!
bagOfElements: aBlockContext 

	| bag |
	bag := Bag new.
	self do: [:each| bag addAll: (aBlockContext value: each)].
	^bag! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 6/24/2008 13:47'!
collect: aBlockContext thatDoesNotCause: errorClass 

	^(Array streamContents: [ :stream |
		self do: [ : each | | errorMet value |
			errorMet := false.
			[ value := aBlockContext value: each ] on: errorClass do: [: exp | errorMet := true ].
			errorMet ifFalse: [ stream nextPut: value ].
			].
		]) as: self species! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 21:25'!
collectBy: aByteSymbol 

	"Duplicate implementation with #collectWith:"
	^self collect: aByteSymbol accessingBlock! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 2/16/2009 00:41'!
collectDictionary: aBlockContext 

	| dictionary |
	dictionary := Dictionary new.
	self do: [:each| dictionary at: each put: (aBlockContext value: each) ].
	^dictionary! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/5/2009 20:29'!
collectForMultiCollection: aBlockContext 
	"no matter how deep a multi-dimensional collection I am, this method
	gets a #collect: on each elements without breaking the dimesion."
	"e.g. #( 1( 2)3) collectForMulitCollection: [:each| each * 2] ==> #(2 #(4) 6)"
	^ self
		collect: [:each | each collectForMultiCollection: aBlockContext]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 21:25'!
collectWith: aByteSymbol 

	"Duplicate implementation with #collectBy:"
	^self collect: aByteSymbol accessingBlock! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 4/5/2008 14:10'!
commonDivisors

	^(self collect: [:integer| integer exactDivisors ]) intersection! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:52'!
detect: aBlockClosure ifFound: ifFoundBlock ifNotFound: ifNotFoundBlock 

	| failedInFinding object |
	failedInFinding := false.
	object := self detect: aBlockClosure ifNone: [ failedInFinding := true ].

	^failedInFinding
		ifTrue: [ ifNotFoundBlock value ]
		ifFalse: [ ifFoundBlock value: object ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:51'!
detectIndex: aBlockContext ifFound: aBlockContext2 ifNotFound: aBlockContext3 

	^self detect: aBlockContext 
		ifFound: [:object| aBlockContext2 value: (self indexOf: object)] 
		ifNotFound: aBlockContext3! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/16/2008 12:56'!
distinguishedBy: aBlockContext 

	^Distinction new
		selectingBlock: aBlockContext;
		putAll: self! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 7/14/2008 15:36'!
doForMulitCollection: aBlockContext printOn: aWriteStream depth: aSmallInteger 

	self do: [ : each | each doForMulitCollection: aBlockContext printOn: aWriteStream depth: aSmallInteger-1 ] separatedBy: [ aSmallInteger-1 timesRepeat: [ aWriteStream cr ]  ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 14:14'!
elementsAsSet

	^self collect: [:each| each asSet ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 14:14'!
equalElementsOfElementsTo: collectionOfCollection

	^self elementsAsSet equalElementsTo: collectionOfCollection elementsAsSet! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 13:54'!
equalElementsTo: aCollection

	^self size = aCollection size and: [
	(self includesAllOf: aCollection) and: [
	aCollection includesAllOf: self ]]	! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 9/18/2009 16:02'!
give: anObject to: aCollection

	self remove: anObject.
	aCollection add: anObject! !

!Collection methodsFor: '*Daliot-group' stamp: 'hjo 6/29/2009 16:50'!
groupBy: aBlockContext 

	"Very similar to #groupBy:having:"
	| dictionary |
	dictionary := Dictionary new.
	self do: [:each| dictionary at: (aBlockContext value: each) add: each ].
	^dictionary! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 4/14/2008 23:51'!
harmonicMean

	^self size / (self collect: [:each| each reciprocal ]) sum! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 9/29/2009 20:25'!
injectAnyInto: aBlockContextWith2Args

	| any | 
	any := self anyOne.
	^(self copyWithout: any) inject: any into: aBlockContextWith2Args! !

!Collection methodsFor: '*Daliot-group' stamp: 'hjo 10/5/2009 20:41'!
intersection

	"This is reimplementation in Squeak. If you wanta better one, port it from Dolphin image."
	^self reducedWith: #intersection:! !

!Collection methodsFor: '*Daliot-group' stamp: 'hjo 4/4/2008 13:47'!
intersectionsWith: aRectangle 

	^(self collect: [:rectangle| rectangle intersect: aRectangle]) reject: [:rect| rect isEmpty ] ! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 6/29/2009 16:46'!
isConsecutiveIntegers

	| sortedIntegers interval |
	sortedIntegers := self asSortedCollection.
	interval := sortedIntegers first to: sortedIntegers last.
	(interval first isInteger and: [ interval last isInteger ]) ifFalse: [^false].
	^interval equalElementsTo: sortedIntegers
! !

!Collection methodsFor: '*Daliot-group' stamp: 'hjo 4/8/2008 11:06'!
isRedundant

	^self asSet size ~= self size! !

!Collection methodsFor: '*Daliot-group' stamp: 'hjo 4/15/2008 18:04'!
isSubcollectionOf: aCollection

	^aCollection includesAllOf: self! !

!Collection methodsFor: '*Daliot-group' stamp: 'hjo 4/22/2008 22:00'!
isUnique

	| uni |
	uni := Set new.
	self do: [:each | (uni includes: each) ifTrue: [^false] ifFalse: [uni add: each ] ].
	^true! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 5/3/2008 12:50'!
keysAndValuesCollect: aBlockContext 

	^Array streamContents: [:stream|
		self keysAndValuesDo: [:key :value| stream nextPut: (aBlockContext value: key value: value)] ]! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 3/31/2008 19:43'!
maximumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) last! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/15/2009 18:49'!
mergeAll

	"#concatenateAll like feature for non-sequenceable collections"
	| greatOne |
	self isEmpty ifTrue: [ ^Bag new ].
	greatOne := self anyOne species new.
	self do: [:each| greatOne addAll: each ].
	^greatOne! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 3/31/2008 19:47'!
minimumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) first! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 5/6/2008 15:22'!
minimumsBy: aByteSymbol 

	^MaxClub new
		evaluator: [:object| (aByteSymbol accessingBlock value: object) negated ];
		putAll: self;
		members! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:50'!
netArea

	^(self collect: [:shape| shape area ]) sum! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 6/29/2009 16:50'!
product

	"WARNING implementation is same with #allMultiplied"
	^self inject: 1 into: [:p :each| p * each ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 9/29/2009 20:31'!
reducedWith: binarySelectorOrOneKeywordSelector

	^self injectAnyInto: [:reduced :each | reduced perform: binarySelectorOrOneKeywordSelector with: each]

	! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 9/11/2008 15:07'!
removeIfExists: anObject

	(self includes: anObject)
		ifTrue: [ self remove: anObject ]! !

!Collection methodsFor: '*Daliot-math' stamp: 'hjo 7/11/2008 15:04'!
sumEvenForEmpty

	^self isEmpty
		ifTrue: [ 0 ]
		ifFalse: [ self sum ]! !

!Collection methodsFor: '*Daliot-group' stamp: 'hjo 6/28/2008 14:12'!
union

	| union |
	union := Set new.
	self do: [ : collection | union addAll: collection ].
	^union! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:03'!
colinear: p1 with: p2

	^((self-p1) crossProduct: (self-p2)) = 0! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:24'!
equals: aPoint 

	^(self x equals: aPoint x) and: [self y equals: aPoint y]! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 12:56'!
pointRectangle

	^self corner: self copy! !

!Point methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 23:05'!
polygonAreaKernel: backPoint with: forePoint

	"Used for calculating area of a polygon. - Private -"
	^self y * (forePoint x - backPoint x)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:42'!
projectionPointTo: aPoint 

	^self projectionPointToUnitPoint: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:26'!
projectionPointToUnitPoint: aPoint 

	^aPoint * (aPoint dotProduct: self)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 14:14'!
projectionTo: aPoint 

	^self dotProduct: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:32'!
projectionToUnitPoint: aPoint 

	^self dotProduct: aPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 23:11'!
rotatedBy90Degrees

	"Or you can just use, #normal truncated."
	^self y negated @ self x! !

!Point methodsFor: '*Daliot' stamp: 'hjo 8/27/2008 12:41'!
sign
	^self x sign @ self y sign! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:19'!
unitPoint

	^self / self r! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 23:13'!
collection

	"Nasty hack for accessing private instance variable 'collection'."
	^collection! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 5/14/2008 16:18'!
nextSeparators

	| positionBeforeSkip positionAfterSkip |
	positionBeforeSkip := self position.
	self skipSeparators.
	positionAfterSkip := self position.
	self position: positionBeforeSkip.
	^self next: positionAfterSkip - positionBeforeSkip! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/19/2008 07:48'!
nextAndSkipSeparators

	| object |
	object := self next.
	self skipSeparators.
	^object! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 12:35'!
nextNumberFromText

	[^Number readFrom: self ] ensure: [self skipSeparators]! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 12:22'!
nextSeparatedString

	[^self upToSeparator] ensure: [self skipSeparators]! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 09:51'!
nextSquareMatrixFromText

	| matrixSize  |
	matrixSize := self nextNumberFromText.
	^Matrix rows: matrixSize columns: matrixSize contents:
		(Array streamContents: [:contentsStream | 
			matrixSize squared timesRepeat: [ contentsStream nextPut: self nextNumberFromText ].
		]).
! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:56'!
upToSeparator

	| posWhenCalled posFound |
	posWhenCalled := self position.
	[self atEnd or: [self peek isSeparator]] whileFalse: [self skip:1].
	posFound := self position.
	self position: posWhenCalled.
	^self next: (posFound-posWhenCalled)! !

!Rectangle class methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:51'!
thatIncludesAllPoints: aCollection

	|xSort ySort|
	xSort := (aCollection collect: [:each| each x]) asSortedCollection.
	ySort := (aCollection collect: [:each| each y]) asSortedCollection.
	^Rectangle origin: xSort first@ySort first corner: xSort last@ySort last! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:25'!
canMergeEastWith: aRectangle 

	^self right = aRectangle left and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeNorthWith: aRectangle 

	^self top = aRectangle bottom and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeSouthWith: aRectangle 

	^self bottom = aRectangle and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeWestWith: aRectangle 

	^self left = aRectangle right and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:19'!
canMergeWith: aRectangle 

	^(self canMergeNorthWith: aRectangle) or: [
	(self canMergeSouthWith: aRectangle) or: [
	(self canMergeWestWith: aRectangle) or: [
	(self canMergeEastWith: aRectangle) ]]]
! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:49'!
isEmpty

	^(self width<= 0) or: [self height <= 0]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:54'!
mergedEastWith: aRectangle 

	^ self left @ self top corner: aRectangle right @ aRectangle bottom! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:52'!
mergedWith: aRectangle 

	(self canMergeNorthWith: aRectangle) ifTrue: [^self mergedNorthWith: aRectangle].
	(self canMergeSouthWith: aRectangle) ifTrue: [^self mergedSouthWith: aRectangle].
	(self canMergeWestWith: aRectangle) ifTrue: [^self mergedWestWith: aRectangle].
	(self canMergeEastWith: aRectangle) ifTrue: [^self mergedEastWith: aRectangle]
! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:26'!
topAndBottomIsSameWith: aRectangle 

	^self top = aRectangle top and: [self bottom = aRectangle bottom ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:55'!
untruncatedCenter

	^(self origin + self corner)/2! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:05'!
xRange

	^Range close: self left open: self right! !

!SimpleButtonMorph methodsFor: '*Daliot-Morphic' stamp: 'hjo 12/3/2008 17:13'!
buttonExpression

	^'target ' , actionSelector! !

!UndefinedObject methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^false! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 21:52'!
bilinearCombinations: aBlockContext 

	"e.g. 3 bilinearCombinations: [:a :b| a * 0.001 + b ]"
	^(0 to: self) collect: [:r| aBlockContext value: (self-r) value: r ]! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 21:55'!
bilinearCombinationsOf: magintude1 and: magnitude2

	"e.g.  3 bilinearCombinationsOf: 0.01 and: 3"
	^self bilinearCombinations: [:a :b | (a*magintude1) + (b*magnitude2) ]
! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 21:57'!
bilinearCombinationsOf: magnitude1 and: magnitude2 origin: magnitude0 

	"e.g.  3 bilinearCombinationsOf: 0.01 and: 3 origin: 100"
	^(self bilinearCombinationsOf: magnitude1 and: magnitude2) + magnitude0! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 6/2/2008 19:31'!
combinationOutOf: anInteger

	^(self permutationOutOf: anInteger) / self factorial! !

!Integer methodsFor: '*Daliot-times' stamp: 'hjo 4/15/2008 17:23'!
copiesOf: anObject

	| copies |
	copies := Array new: self.
	1 to: self do: [:i|
		copies at: i put: anObject copy].
	^copies! !

!Integer methodsFor: '*Daliot-times' stamp: 'hjo 4/15/2008 17:23'!
deepCopiesOf: anObject

	| copies |
	copies := Array new: self.
	1 to: self do: [:i|
		copies at: i put: anObject deepCopy].
	^copies! !

!Integer methodsFor: '*Daliot-times' stamp: 'hjo 4/15/2008 17:23'!
evaluationsOf: aBlockClosure 
	
	|objects|
	objects := Array writeStream: self.
	self timesRepeat: [ objects nextPut: aBlockClosure value ].
	^objects contents! !

!Integer methodsFor: '*Daliot-primes' stamp: 'hjo 4/5/2008 16:11'!
exactDivisors

	|ed sq |
	ed := OrderedCollection new.
	sq := self sqrt truncated.
	sq squared = self ifTrue: [ed add: sq. sq := sq-1].
	sq to: 1 by: -1 do: [ :d |
		( self rem: d ) = 0
			ifTrue: [
				ed addFirst: d.
				ed addLast: self/d
			]
	].
	^ed asArray! !

!Integer methodsFor: '*Daliot-times' stamp: 'hjo 4/15/2008 17:23'!
instancesOf: aClass

	| instances |
	instances := Array new: self.
	1 to: self do: [:i|
		instances at: i put: aClass new].
	^instances! !

!Integer methodsFor: '*Daliot-primes' stamp: 'hjo 4/17/2008 11:04'!
isPerfectNumber

	^self exactDivisors sum = (self + self)! !

!Integer methodsFor: '*Daliot-primes' stamp: 'hjo 4/7/2008 12:21'!
isRelativelyPrimeTo: anInteger

	^(self gcd: anInteger) = 1! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 14:28'!
modular: anInteger 

	^self < 0 
		ifTrue: [(self abs / anInteger) ceiling * anInteger + self modular: anInteger]
		ifFalse: [self rem: anInteger]! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:27'!
permutationOutOf: anInteger

	|product|
	product := 1.
	anInteger - self  + 1 to: anInteger do: [:x| product := product * x].
	^product! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/18/2008 09:49'!
positiveIntegerRoot: anInteger

	| sd primeFactors powers |
	sd := self standardDecomposition.
	primeFactors := sd asSet.
	powers := primeFactors collect: [:each| sd occurrencesOf: each ].
	(powers size = 1) ifFalse: [ self error: 'failed.' ].
	^primeFactors product raisedTo: powers anyOne / anInteger! !

!Integer methodsFor: '*Daliot-primes' stamp: 'hjo 4/7/2008 14:59'!
primeFactors

	^self standardDecomposition asSet! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 5/8/2008 13:17'!
ramanujan

	^(self to: 2 by: -1) inject: 1 into: [:f0 :n| ( (f0 * n) + 1 ) sqrt ]! !

!Integer methodsFor: '*Daliot-primes' stamp: 'hjo 4/7/2008 14:57'!
standardDecomposition

	| sd d x |
	sd := Bag new.
	d := 2.
	x := self.

	[x >= d] whileTrue: [
		(x rem: d) = 0
			ifTrue: 
			[
				x := x / d.
				sd add: d
			]
			ifFalse:
			[
				d := d + 1
			]
	].
	^sd! !

!Integer methodsFor: '*Daliot-primes' stamp: 'hjo 9/11/2008 18:32'!
sumOfProperDivisors

	^self exactDivisors sum - self! !

!Integer methodsFor: '*Daliot-times' stamp: 'hjo 7/22/2008 20:01'!
timesCollect: aBlockContext 

	^Array streamContents: [ : stream |
		self timesRepeat: [ stream nextPut: aBlockContext value ]
	]! !

!BlockClosure methodsFor: '*Daliot-common' stamp: 'hjo 6/20/2011 00:07'!
ascendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) < (self value: objectB) ]! !

!BlockClosure methodsFor: '*Daliot' stamp: 'hjo 4/28/2011 22:24'!
beTranscriptedToSeeChangeBy: aBlockClosure 
	
	Transcript print: aBlockClosure;cr.
	Transcript tab print: self value;cr.
	aBlockClosure value.
	Transcript tab print: self value;cr.
	Transcript cr;flush. ! !

TestRunner subclass: #DaliotsTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:22'!
browseUnsentMessages
| sentClasses methods  coveredMethods uncoveredMethods references |

	references := classesSelected gather: [ :class |
		class methodDict values , class class methodDict values gather: [ :method |
			(method literals copyWithoutAll: class allSelectors , class class allSelectors)
				select: [ :each | each isSymbol ] ] ].

	coveredMethods := OrderedCollection new.
	references
		do: [:each | coveredMethods addAll: (SystemNavigation new allImplementorsOf: each) ].
sentClasses := Smalltalk allClasses select: [:c| (c category = #EcologicalBinPacking) and: [ c superclass ~= TestCase ]].
	methods := OrderedCollection new.
	sentClasses do: [:ee| ee selectors do: [:ss| methods add: (MethodReference class:ee selector: ss) ]].

	coveredMethods := coveredMethods select: [:me| |class| class := Smalltalk at: me classSymbol. class category =  #EcologicalBinPacking].

	uncoveredMethods := methods copyWithoutAll: coveredMethods. 
	SystemNavigation new browseMessageList: uncoveredMethods name: 'Untested Methods' ! !

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:16'!
classMenu: aMenu
	| menu |
	menu := aMenu
		title: 'Classes';
		yourself.
	self browserEnvironment notNil ifTrue: [ 
		menu
			add: 'Browse classes' action: #browseTestClasses;
			add: 'Browse referenced classes' action: #browseReferencedClasses ].
	^ menu
		add: 'Browse sent messages' action: #browseSentMessages;
		add: 'Browse unsent messages' action: #browseUnsentMessages;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Refresh' action: #updateClasses;
		yourself.! !

!Browser class methodsFor: '*Daliot' stamp: 'hjo 10/21/2009 22:24'!
fullAtRandom

	| method |
	method := CompiledMethod allInstances atRandom.
	^self fullOnClass: method methodClass selector: method selector! !

!Character methodsFor: '*Daliot' stamp: 'hjo 11/22/2008 12:44'!
caseReversed

	^self isLowercase
		ifTrue: [ self asUppercase ]
		ifFalse: [ self asLowercase ]! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/23/2008 20:15'!
equals: aNumber

	"Ported from Dolphin 4.0 by Howard J. Oh"
	| max significantDifference |
	significantDifference := 1.0e-9.
	^(max := self abs max: aNumber abs) <= significantDifference
		or: [(self-aNumber) abs < (significantDifference * max)]! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:03'!
equals: trueNumber withError: errorNumber

	^(self - trueNumber) abs <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:05'!
equals: trueNumber withRelativeError: errorNumber

	^(self relativeTo: trueNumber) <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 8/27/2008 12:41'!
equalsTo: aNumber

	^self equals: aNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/13/2009 10:25'!
ifPositive: positiveBlock ifZero: zeroBlock ifNegative: negativeBlock

	self > 0 ifTrue: [ ^positiveBlock value ].
	self < 0 ifTrue: [ ^negativeBlock value ].
	self = 0 ifTrue: [ ^zeroBlock value ].
	self error: 'What am I?'! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 22:42'!
quoAndRem: aNumber

	"This method is default in Dolphin Smalltalk but not in Squeak."
	^{self quo: aNumber . self rem: aNumber}! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:06'!
relativeTo: trueNumber

	^(self - trueNumber)/trueNumber
! !

!Interval class methodsFor: '*Daliot' stamp: 'hjo 4/27/2009 23:12'!
multiplesOf: anInteger below: anInteger2 

	^anInteger to: anInteger2-1 by: anInteger! !

!Interval methodsFor: '*Daliot' stamp: 'hjo 9/11/2008 18:43'!
amicablePairs


	| numbersToCheck pairs |
	numbersToCheck := self.
	pairs := OrderedCollection new.
	
	[numbersToCheck isEmpty] whileFalse: [ 	| number otherNumber |
		number := numbersToCheck first.
		numbersToCheck := numbersToCheck first + 1 to: numbersToCheck last.
		otherNumber := number sumOfProperDivisors.
		((numbersToCheck includes: otherNumber) and: [ otherNumber sumOfProperDivisors = number ])
			ifTrue: [
				pairs add: (Array with: number with: otherNumber).
				 ]
	].
	^pairs! !

!Interval methodsFor: '*Daliot' stamp: 'hjo 8/27/2008 09:56'!
asArrayedCollection

	^self collect: [: each | each ]! !

!Interval methodsFor: '*Daliot' stamp: 'hjo 4/27/2009 23:03'!
sum

	"fast version"
	^self size * (self first + self last) / 2! !

TestCase subclass: #DaliotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/21/2011 10:59'!
testConcatenateAll

	self assert: 'daysbikeDistancepushUpsdophinChangeLogSize' equals: #('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAll.
	self assert: #(1 2 3 4 10 11 12 13 14 15) equals: {(1 to: 4). (10 to: 15)} concatenateAll.
	self assert: (ByteArray withAll: #(50 10 20 100 110 120 200 220 250 254)) equals: 
		(OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAll! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/21/2011 11:00'!
testConcatenateAllSeparatedBy

	self assert: 'days bikeDistance pushUps dophinChangeLogSize' equals: (#('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAllSeparatedBy: ' ').
	self assert: #(1 2 3 4 $x 10 11 12 13 14 15) equals: ({(1 to: 4) . (10 to: 15)} concatenateAllSeparatedBy: 'x').
	self assert: (ByteArray withAll: #(50 10 20 1 2 3 100 110 120 1 2 3 200 220 250 254)) equals: 
		((OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAllSeparatedBy: (ByteArray withAll: #(1 2 3)))! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/21/2009 18:53'!
testDeinterlacedBy

	| result |
	result := #(1 2 3 4 5 6 7) deinterlacedBy: 2.
	self assert: result first = #(1 3 5 7).
	self assert: result second = #(2 4 6)! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/16/2008 18:04'!
testInOrder

	self assert: 'abcd' isInOrder.
	self deny: 'acbd' isInOrder! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 20:50'!
testInjectAnyInto

	| array |
	array := #(1 2 3 4).
	self assert: (array injectAnyInto: [:value :each | value + each ]) = 10.
	self assert: (array injectAnyInto: [:value :each | value * each ]) = 24.
	self assert: (array injectAnyInto: [:value :each | value / each ]) = (1/24).
	self assert: (array injectAnyInto: [:value :each | value max: each ]) = 4.! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/5/2009 20:38'!
testIntersection

	self assert: #((1 2 3 4 5) ( 2 3 4 5) (1 2 3 4)) intersection = #(2 3 4)! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/26/2008 14:27'!
testModular

	self assert: (100 modular: 9) equals: 1.
	self assert: (-100 modular: 9) equals: 8! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 16:10'!
testPointRotatedBy90Degrees

	self assert: (3@4) rotatedBy90Degrees equals: (-4 @ 3)! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 20:51'!
testReducedWith

	| array |
	array := #(1 2 3 4).
	self assert: (array reducedWith: #+) = 10.
	self assert: (array reducedWith: #*) = 24.
	self assert: (array reducedWith: #/) = (1/24).
	self assert: (array reducedWith: #max:) = 4.! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2008 18:51'!
testSelectIndicies

	self assert: ('hello i am daliot' selectIndices: [ :char | char = $o ]) equals:  #(5 16)! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 12:19'!
testUnitPoint

	self assert: (3@4) unitPoint equals: (0.6 @ 0.8)! !

TestCase subclass: #PointProjectionTest
	instanceVariableNames: 'referencePoint point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:00'!
setUp

	super setUp.
	point := 0@2.
	referencePoint := 4@3! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointTo

	self assert: (point projectionPointTo: referencePoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointToUnitPoint

	self assert: (point projectionPointToUnitPoint: referencePoint unitPoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 14:10'!
testProjectionTo

	self assert: (point projectionTo: referencePoint) equals: 1.2! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 15:50'!
testProjectionToUnitPoint

	self assert: (point projectionToUnitPoint: referencePoint unitPoint) equals: 1.2! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:41'!
asArrayedCollection

	^self! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 11:17'!
includesKey: anInteger 

	self isEmpty ifTrue: [^false].
	^anInteger between: 1 and: self size ! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 6/12/2008 09:23'!
modify: aBlockContext 

	1 to: self size do: [:index| self at: index modify: aBlockContext ]! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 9/21/2008 18:21'!
modify: aBlockContext those: filteringBlock

	1 to: self size do: [ :index | 
		(filteringBlock value: (self at: index))
			ifTrue: [ self at: index modify: aBlockContext ] ]! !

!MCVersionInspector methodsFor: '*Daliot' stamp: 'hjo 2/7/2011 18:10'!
copyAllVersionsTo: repository

	1 to: self versionList size do: [:ii| 
		self versionSelection: ii. 
		repository storeVersion: version 
	]. ! !

!Class methodsFor: '*Daliot' stamp: 'hjo 10/4/2008 17:41'!
copyAs: newClassName
	
	| newDefinition compiledClass |
	(Smalltalk includesKey: newClassName asSymbol)
		ifTrue: [^ self error: newClassName , ' already exists'].

	newDefinition := self definition copyReplaceAll: '#' , self name asString with: '#' , newClassName asString.
	

	compiledClass := Compiler evaluate: newDefinition logged: true.
	compiledClass copyAllCategoriesFrom: (Smalltalk at: self name).
	compiledClass class copyAllCategoriesFrom: (Smalltalk at: self name) class.
	^compiledClass! !

!Class methodsFor: '*Daliot' stamp: 'hjo 10/4/2008 17:41'!
copyAs: newClassName into: categoryNameForNewClass
	
	^(self copyAs: newClassName) category: categoryNameForNewClass! !

!SequenceableCollection class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:54'!
writeStream

	"Dolphin Method"
	^self new writeStream! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/24/2011 09:09'!
allSatisfyCouple: aBlockClosure 

	self do: [:x| (aBlockClosure value: x first value: x second) ifFalse: [^false] ] spanSize: 2.
	^true
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 2/8/2009 13:24'!
collectCouple: aBlockContext 

	self assert: [aBlockContext argumentCount = 2].
	^(1 to: self size - 1) collect: [:index| aBlockContext value: (self at: index) value:(self at: index+1) ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 19:16'!
concatenateAll

	^self concatenateAllSeparatedBy: self species new! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/6/2008 15:41'!
concatenateAllSeparatedBy: aCollection

	|stream|
	self isEmpty ifTrue: [^self species new].
	stream := self first asArrayedCollection species writeStream.
	self do: [:each| stream nextPutAll: each asArrayedCollection ] separatedBy: [stream nextPutAll: aCollection].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 7/9/2008 11:13'!
concatenateAllWithDoubleLineBreaks

	^self concatenateAllSeparatedBy:
'

'! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 15:40'!
copyFrom1ToSubCollectionIndexMinus1: anArray

	^self copyFrom: 1 to: (self indexOfSubCollection: anArray)-1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 16:40'!
copyFromFirstTo: anInteger 

	^self copyFrom: 1 to: anInteger! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/15/2008 18:14'!
copyToEndFrom: anInteger 

	^self copyFrom: anInteger to: self size! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 16:41'!
copyToLastFrom: anInteger 

	^self copyFrom: anInteger to: self size! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 17:24'!
copyToLastFromObject: anObject 

	^self copyToLastFrom: (self indexOf: anObject)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/24/2008 11:45'!
copyWithoutLast

	^self copyFromFirstTo: self size-1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 10/21/2009 18:50'!
deinterlacedBy: aSmallInteger 

	^(1 to: aSmallInteger) collect: [: startValue| 
		(startValue to: self size by: aSmallInteger)
			collect: [:index| self at: index]
		]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:10'!
detectIndex: aBlockContext 

	^self indexOf: (self detect: aBlockContext)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:55'!
do: aBlockClosure spanSize2: anInteger

	"Slower than #do:spanSize: , but better understandable."
	| span feeder |
	
	span := OrderedCollection withAll: (self copyTo: anInteger).
	feeder := (self copyFrom: anInteger+1) readStream.

	[ aBlockClosure value: span. feeder atEnd ]
	whileFalse: 
	[
		span removeFirst.
		span addLast: feeder next.
	]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 18:41'!
do: aBlockClosure spanSize: anInteger

	|previousItems|

	anInteger-1 > self size ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: 1 to: anInteger-1).
	anInteger to: self size do:
		[:i| previousItems addLast: (self at:i).
		aBlockClosure value: previousItems.
		previousItems removeFirst]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:54'!
doCouple: aBlockClosure

	self do: [:x| aBlockClosure value: x first value: x second] spanSize: 2
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:32'!
doRolled: aBlockClosure spanSize: anInteger 

	|previousItems|

	self size < anInteger ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: self size - anInteger + 2).
	self do: [:each| 
		previousItems addLast: each. 
		aBlockClosure value: previousItems. 
		previousItems removeFirst ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:54'!
dot: anArray

	"FASTER VERSION:"
	|sumForDot|
	self assert: [ self size = anArray size ].
	sumForDot := 0.
	1 to: self size do: [:i| sumForDot := (self at: i) * (anArray at: i) + sumForDot ].
	^sumForDot
	"SMART LOOKING VERSION:" 
	"^(self convolve: aVector) sum"
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/10/2008 15:54'!
indexOfMaximum

	^self indexOfMaximumBy: #yourself! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/10/2008 15:59'!
indexOfMaximumBy: accessingSymbol 

	| maxClub |
	maxClub := MaxClub new evaluator: [:index| (self at: index) perform: accessingSymbol ].
	maxClub putAll: (1 to: self size).
	maxClub members size = 1 ifFalse: [ self error: 'not one maximum here.' ].
	^maxClub members anyOne! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:00'!
indicesOf: anObject

	^(1 to: self size) select: [:each| (self at:each) = anObject]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/16/2008 17:57'!
isInOrder

	| sortedSelf | 
	sortedSelf := self asSortedCollection.
	^(1 to: self size) allSatisfy: [:index| (sortedSelf at: index) = (self at: index) ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:53'!
linearlyCombinatedBy: anArray

	^(self dot: anArray) / anArray sum! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/26/2008 11:18'!
merge1Prefix: aByteString 

	| index |
	index := self detectIndex: [:each| each = aByteString ].
	^(self copyFromFirstTo: index-1),
		{(self at: index) , (self at: index+1)},
		(self copyToLastFrom: index+2)! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/27/2008 12:48'!
mergePrefix: aByteString 

	^self detectIndex: [:each| each = aByteString ]
		ifFound: [ :index |
			(self copyFromFirstTo: index-1),
				{(self at: index) , (self at: index+1)},
				(self copyToLastFrom: index+2) ]
		ifNotFound: [ self ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 9/17/2011 19:39'!
multiDimensionalCollect: aBlockContext
	| stream |
	stream := self species writeStream.
	self
		multiDimensionalDoWithArray: [ :sample | stream nextPut: ([ :each | aBlockContext valueWithArguments: each ] value: sample) ].
	^ stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 9/17/2011 19:39'!
multiDimensionalDo: aBlockContext 

	^self multiDimensionalDoWithArray: [:each| aBlockContext valueWithArguments: each ]
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 9/17/2011 19:39'!
multiDimensionalDoWithArray: monoBlock

	self isEmpty ifTrue: [^self].
	self size = 1 ifTrue: [^self first do: [:oneParam| monoBlock value: (Array with: oneParam)]].
	self first do: [:first| 
		(self copyFrom: 2 to: self size) multiDimensionalDoWithArray: [:paramWithoutFirst|
			monoBlock value: (Array with: first) , paramWithoutFirst
		]]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 9/17/2011 19:39'!
multiDimensionalSelect: aBlockContext 

	^Array streamContents: [:stream|
		self multiDimensionalDoWithArray: [:each| 
			(aBlockContext valueWithArguments: each)
				ifTrue: [stream nextPut: each]
			]
		]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 6/30/2008 09:39'!
numbersEqualTo: anArray 

	self size = anArray size ifFalse: [ ^false ].
	
	^(1 to: anArray size) allSatisfy: [ : each |  (self at: each) equals: (anArray at: each) ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/23/2008 12:09'!
reverseAt: aSmallInteger 

	^self at: self size - aSmallInteger + 1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 5/21/2008 18:47'!
reverseIndexOf: anObject
	
	self size to: 1 by: -1 do: [ :index| 
		(self at: index) = anObject ifTrue: [^index]
		].
	^0! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 9/21/2008 18:25'!
selectIndices: aBlockContext 

	^(1 to: self size) select: [:index | aBlockContext value: (self at: index) ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/17/2009 18:19'!
with: aSequencableCollection allSatisfy: aBlockContext 

	self assert: [ self size = aSequencableCollection size ].
	^(1 to: self size) allSatisfy: [:index| aBlockContext value: (self at: index) value: (aSequencableCollection at: index)]! !

!SmalltalkImage methodsFor: '*Daliot' stamp: 'hjo 6/11/2011 13:27'!
allObjects

	| topClasses |
	topClasses := self allClasses select: [:cl| cl superclass isNil ].
	^Array streamContents: [:stream| 
		topClasses do: [:each| stream nextPutAll: each allSubInstances ]  ].! !

!SmalltalkImage methodsFor: '*Daliot' stamp: 'hjo 6/11/2011 11:24'!
allObjectsThatCanRespondToAllOf: arrayOfSelectors

	^(((self systemNavigation environment) reductionOfAllClassesThatCanUnderstandAllOf: arrayOfSelectors) collect: [:class| class allSubInstances]) concatenateAll.! !

Object subclass: #DaliotUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotUtility methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 09:45'!
classCategoriesNotCoveredByMonticello

	| all packageNames |
	all := SystemOrganizer allInstances anyOne categories.

	packageNames := MCWorkingCopy allInstances collect: [:each | each package name ].

	^all reject: [:ca| packageNames anySatisfy: [:pa| 
		ca beginsWith: pa
		]].
! !

!DaliotUtility methodsFor: 'as yet unclassified' stamp: 'hjo 12/24/2008 14:08'!
classesThatCanUnderstandAll: arrayOfSelectors

	^Smalltalk allClasses , (Smalltalk allClasses collect: [:c| c class ]) 
		select: [:e| arrayOfSelectors allSatisfy: [:s| e canUnderstand:s]].

! !

!DaliotUtility methodsFor: 'foot prints' stamp: 'hjo 12/14/2008 18:19'!
createClassFootPrintFile

	self createFootPrintFileExtension: '.classDump' data: (Smalltalk allClasses sortBy: #name ascendingSortBlock) byDong:  [:stream :c| stream print: c; cr ]! !

!DaliotUtility methodsFor: 'foot prints' stamp: 'hjo 12/14/2008 18:18'!
createFootPrintFileExtension: aString data: aSortedCollection byDong: aBlock

	FileStream newFileNamed: ((FileDirectory baseNameFor: (FileDirectory localNameFor: 	SmalltalkImage current imageName)) , aString) do: 
		[:stream|
			aSortedCollection do: [:object |  aBlock value: stream value: object ]
		]
! !

!DaliotUtility methodsFor: 'foot prints' stamp: 'hjo 12/14/2008 18:20'!
createFootPrintFiles

	self createClassFootPrintFile.
	self createMethodFootPrintFile! !

!DaliotUtility methodsFor: 'foot prints' stamp: 'hjo 12/14/2008 18:19'!
createMethodFootPrintFile

	self createFootPrintFileExtension: '.methodDump' data: (CompiledMethod allInstances collect: [:e| e methodReference ]) asSortedCollection byDong:  [:stream :m| stream nextPutAll: m stringVersion; cr  ]

	! !

!DaliotUtility methodsFor: 'as yet unclassified' stamp: 'hjo 5/18/2008 15:08'!
dabDateWmvUriFrom: aString

	| wmv index http |
	wmv := aString indexOfSubCollection: '.wmv'.

	index := 0.
	[index := aString indexOfSubCollection: 'http://' startingAt: index+1.

	index < wmv] whileTrue: [http := index].
	^aString copyFrom: http to: wmv+3 
! !

!DaliotUtility methodsFor: 'foot prints' stamp: 'hjo 12/14/2008 18:37'!
readAndFindMissingClassFromClassFootPrintFile: aString

	| missings |
	missings := OrderedCollection new.
	FileStream oldFileNamed: aString do: 
		[:stream| 
			[stream atEnd] whileFalse: 
				[	| className |
					className := stream nextLine  withBlanksTrimmed asSymbol.
					(Smalltalk includesKey: className)
						ifFalse: [missings add: className ] ]
		].
	
	^missings! !

Object subclass: #Distinction
	instanceVariableNames: 'selectingBlock rejectedOnes selectedOnes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!Distinction methodsFor: 'put' stamp: 'hjo 5/16/2008 16:27'!
put: anObject

	((self selectingBlock value: anObject)
		ifTrue: [ self selectedOnes ]
		ifFalse: [ self rejectedOnes ])
		add: anObject! !

!Distinction methodsFor: 'put' stamp: 'hjo 5/16/2008 12:57'!
putAll: aCollection

	aCollection do: [:each| self put: each ] ! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 13:00'!
rejectedOnes
	rejectedOnes isNil ifTrue: [
		self rejectedOnes: OrderedCollection new
	].
	^rejectedOnes! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 13:00'!
rejectedOnes: anOrderedCollection 

	rejectedOnes := anOrderedCollection 
! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 16:28'!
selectedOnes
	selectedOnes isNil ifTrue: [
		self selectedOnes: OrderedCollection new
	].
	^selectedOnes! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 16:29'!
selectedOnes: anOrderedCollection 
	
	selectedOnes := anOrderedCollection 
! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 12:59'!
selectingBlock
	^selectingBlock! !

!Distinction methodsFor: 'accessing' stamp: 'hjo 5/16/2008 12:57'!
selectingBlock: aBlockContext 
	selectingBlock := aBlockContext ! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/15/2008 10:48'!
arrayOfMe
	
	^Array with: self! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/5/2009 20:28'!
collectForMultiCollection: aBlockContext 
	^ aBlockContext value: self! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/14/2008 15:37'!
doForMulitCollection: aBlockContext printOn: aWriteStream depth: aSmallInteger 

	aBlockContext value: self! !

!Object methodsFor: '*Daliot-CompactConditionals' stamp: 'hjo 7/4/2009 20:42'!
ifI: testingSelector thenI: positiveAction otherwiseI: negativeAction 
	^ self perform: ((self perform: testingSelector)
		ifTrue: [positiveAction]
		ifFalse: [negativeAction])! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/17/2008 10:18'!
isAheadOf: anObject in: anArray 

	^(anArray indexOf: self) < (anArray indexOf: anObject)! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 13:29'!
printOn: aStream tabLevel: anInteger

	aStream tab: anInteger.
	self printOn: aStream	! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 09:51'!
printStringTabLevel: anInteger

	^String streamContents: [:stream| self printOn: stream tabLevel: anInteger ]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/31/2009 22:45'!
revisit: aString

	"does nothing"
	"Use this method for leaving traceable comment."! !

!Object methodsFor: '*Daliot' stamp: 'hjo 12/8/2008 18:26'!
selectInInstanceVariables: aBlockContext 

	^((1 to: self class instSize) collect: [:instVarIndex | self instVarAt: instVarIndex ])
		select: [:object| aBlockContext value: object ]

		! !

!Object methodsFor: '*Daliot' stamp: 'hjo 12/8/2008 19:17'!
selectInInstanceVariables: aBlockContext goDepth: aSmallInteger
	
	^Array streamContents: [:stream|
		self selectInInstanceVariables: aBlockContext goDepth: aSmallInteger on: stream
		]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/5/2009 20:38'!
selectInInstanceVariables: aBlockContext goDepth: aSmallInteger on: aWriteStream 
	
	| indices allInstVarObjects |
	indices := 1 to: self class instSize.
	allInstVarObjects := indices
				collect: [:instVarIndex | self instVarAt: instVarIndex].
	aSmallInteger > 0
		ifTrue: [allInstVarObjects
				do: [:object | object
						selectInInstanceVariables: aBlockContext
						goDepth: aSmallInteger - 1
						on: aWriteStream]]
		ifFalse: [allInstVarObjects
				do: [:object | (aBlockContext value: object)
						ifTrue: [aWriteStream nextPut: object]]]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 7/11/2009 12:24'!
showOnTranscript
	Transcript show: self;
		 cr; flush! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/10/2010 10:57'!
transcript

	Transcript print: self; cr; flush! !

!Object methodsFor: '*Daliot' stamp: 'hjo 8/11/2011 14:56'!
transcriptContext

	Transcript 
		print: thisContext sender;
		cr.! !

Object subclass: #OneOfArray
	instanceVariableNames: 'array selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!OneOfArray classSide methodsFor: 'instance creation' stamp: 'hjo 9/6/2011 16:44'!
array: anArray selectionIndex: anInteger

	^self new array: anArray selectionIndex: anInteger! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:31'!
array
	^ array! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:31'!
array: anArray
	array := anArray! !

!OneOfArray methodsFor: 'initialize-release' stamp: 'hjo 9/6/2011 16:43'!
array: anArray selectionIndex: anInteger

	self assert: [anInteger between: 1 and:  anArray size ].
	array := anArray.
	selectionIndex := anInteger. 

	! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:33'!
isSelectingFirstOne

	^selectionIndex = 1! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:33'!
isSelectingLastOne

	^selectionIndex = array size! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:32'!
nextOne

	^array at: selectionIndex+1! !

!OneOfArray methodsFor: 'near selection' stamp: 'hjo 9/6/2011 16:41'!
nextToSelection 

	^array at: selectionIndex + 1! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:32'!
previousOne

	^array at: selectionIndex-1! !

!OneOfArray methodsFor: 'near selection' stamp: 'hjo 9/6/2011 16:41'!
previousToSelection 

	^array at: selectionIndex - 1! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:40'!
selectFirstOne 

	selectionIndex := 1! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:40'!
selectLastOne 

	selectionIndex := array size.! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:38'!
selectNextOne

	selectionIndex + 1 > array size ifTrue: [^false].
	selectionIndex := selectionIndex + 1.
	^true.! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:39'!
selectNextOneCyclically

	| success |
	success := self selectNextOne.
	success ifFalse: [ self selectFirstOne ].! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:38'!
selectPreviousOne

	selectionIndex - 1 < 1 ifTrue: [^false].
	selectionIndex := selectionIndex - 1.
	^true.! !

!OneOfArray methodsFor: 'change selection' stamp: 'hjo 9/6/2011 16:40'!
selectPreviousOneCyclically

	| success |
	success := self selectPreviousOne.
	success ifFalse: [ self selectLastOne ].! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:32'!
selectedOne

	^array at: selectionIndex! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:31'!
selectionIndex
	^ selectionIndex! !

!OneOfArray methodsFor: 'accessing' stamp: 'hjo 9/6/2011 16:42'!
selectionIndex: anInteger

	self assert: [ anInteger between: 1 and: array size ].
	selectionIndex := anInteger! !

!EllipseMorph methodsFor: '*Daliot' stamp: 'hjo 10/25/2008 18:51'!
publishedActions

	^super publishedActions! !
